/*
 * Datei.....: _MENU_TO.PRG
 * Autor.....: Volker Sengler
 * Anschrift.: Postfach 2322  W-7520 Bruchsal 1
 * CIS-ID....: 100031,674
 * andere ID.: -
 * Version...: V1.24
 * Datum.....: $Datum$
 * Revision..: $Revision$
 * Logdatei..: $Logfile$
 *
 *  Alle Programmteile sind von Volker Sengler erstellt worden und
 *  damit frei von Rechten Dritter. Der Autor verzichtet auf seine
 *  Rechte und stellt damit dieses Programm der Allgemeinheit zur
 *  Verfgung (Public Domain).
 *
 *  Versionsnderungen:
 *  ===================
 *
 *   V1.1: 19.12.1991 - Volker Sengler
 *         - Durch Weglassen des Parameters Spalte bzw. bei
 *           bergabe eines negativen Wertes wird der Prompt-Text
 *           automatisch zentriert.
 *
 *   V1.2: 28.01.1992 - Volker Sengler
 *         - Konvertierung zur Aufnahme in DF-LIB
 *         - nur noch Variablen vom Typ LOCAL bzw. STATIC
 *         - ungarische Notation
 *
 *  V1.21: 10.02.1992 - Volker Sengler
 *         - Rountinen ohne '_' (nur eigene "interne" Routine)
 *
 *  V1.22: 21.02.1992 - Volker Sengler
 *         - Weitere Anpassung an die DF-LIB
 *         - Testroutine DF_TEST erstellt
 *
 *  V1.23: 08.03.1992 - Volker Sengler
 *         - Dateiheader angepat
 *
 *  V1.24: 15.03.1992 - Stefan Ditscheid
 *         - Funktionsheader angepat ($LIBS$)
 *
 *  Revisionshinweise:
 *  ==================
 *
 *  $Log$
 *
 */

/************************* PreProzessor-Anweisungen ***********************/
#include 'INKEY.CH'
*
#define  MT_POS_X  1
#define  MT_POS_Y  2
#define  MT_TEXT   3
#define  MT_INFO   4
#define  MT_KEYPOS 5
#define  MT_KEY    6
/**************************************************************************/
*
STATIC aMenuList  := {}
STATIC cMenuKeys  := ''
STATIC nMenuWidth := 0
*
/****************************** TESTROUTINE *******************************/
#ifdef DF_TEST
  PROCEDURE DF_Test
    LOCAL nWahl
    *
    CLS
    SET MESSAGE TO 20 CENTER
//  Werden die #translate-Befehle "umgebogen", knnen auch folgende
//  Zeilen verwendet werden.
//  @ 1, 5 PROMPT 'Erster Menpunkt' MESSAGE 'Das ist Nummer 1!'
//  @ 2, 4 PROMPT ' Zweiter Punkt'   MESSAGE 'Spaces werden nicht als Marker verwendet!'
//  @ 3, 2 PROMPT '   Dritter Punkt' MESSAGE 'Egal wieviel leerzeichen !'
//  @ 4, 4 PROMPT 'Vierter ~Punkt'   MESSAGE 'Aber auch jedes bel. Zeichen !'
//  @ 5,-1 PROMPT 'Fnfter Punkt'    MESSAGE 'und automatisch zentriert !'
//  MENU TO nWahl
    DF_Prompt(1, 5, 'Erster Menpunkt', 'Das ist Nummer 1!')
    DF_Prompt(2, 4, ' Zweiter Punkt',   'Spaces werden nicht als Marker verwendet!')
    DF_Prompt(3, 2, ' Dritter Punkt',   'Egal wieviel leerzeichen !')
    DF_Prompt(4, 4, 'Vierter ~Punkt',   'Aber auch jedes bel. Zeichen !')
    DF_Prompt(5,-1, 'Fnfter Punkt',    'und automatisch zentriert !')
    nWahl := DF_MenuTo(2)
    ? 'MENU TO lieferte als Ergebnis: ', nWahl
  RETURN
#endif
/**************************************************************************/

*Ŀ
*                          PROMPT - Pendant                          
*
/*  $DOC$
 *  $FUNCNAME$
 *     DF_Prompt()
 *  $ONELINER$
 *     Hinzufgen eines Prompts fr MENU TO
 *  $SYNTAX$
 *     DF_Prompt(<nZeile>, [<nSpalte>], <cText> [,<cHinweis>]) -> NIL
 *  $ARGUMENTS$
 *     <nZeile>   - Die Zeile, in der der Text erscheinen soll.
 *     <nSpalte>  - Die Spalte, in der der Text erscheinen soll.
 *                  Ist <nSpalte> negativ oder wird NIL bergeben, so wird der
 *                  Text zentriert.
 *     <cText>    - Ist der als Prompt anzuzeigende Text.
 *                  Das Tilde-Zeichen (~) im String gibt an, da das folgende
 *                  Zeichen mit diesem Prompt verknpft wird. Ist das Zeichen
 *                  nicht enthalten, wird das erste Zeichen, das KEIN Leer-
 *                  zeichen ist, verwendet. Dieses Zeichen wird mit der
 *                  Unselected-Farbe markiert.
 *     <cHinweis> - Ist dieser String angegeben, so wird er in der ber
 *                  SET MESSAGE TO definierten Zeile als zustzlicher Text
 *                  angezeigt, wenn der dazugehrige Prompt mit den Cursor-
 *                  Tasten aktiviert wird.
 *  $RETURNS$
 *     ---
 *  $DESCRIPTION$
 *     DF_Prompt() ist als Ersatz fr den @...PROMPT-Befehl definiert.
 *     Die damit erstellten Prompts werden in einer Variablen gespeichert, um
 *     dann DF_MenuTo() zur Verfgung zu stehen.
 *
 *     Durch den Aufruf von DF_Prompt() wird der Text sowie ggf. der dazuge-
 *     hrige Hinweistext angezeigt und das Zeichen zur Direkt-Wahl hervor-
 *     gehoben angezeigt.
 *
 *     Die #translate-Funktion von @..PROMPT kann leicht auf diese Funktion
 *     verbogen werden, um den Befehl auf diese Funktion umzuleiten.
 *     Dazu ist lediglich __AtPrompt gegen DF_Prompt auszutauschen.
 *
 *     ACHTUNG !
 *     DF_Prompt() kann nur in Verbindung mit DF_MenuTo() eingesetzt werden.
 *
 *     Die genaue Funktionsweise des Prompt-Men-System ist unter der Funktion
 *     DF_MenuTo beschrieben.
 *  $EXAMPLES$
 *              // normaler Prompt in oberer, linken Ecke definieren
 *     DF_Prompt( 0,  0, 'Men-Punkt 1')
 *              // Prompt in 2. Zeile zentriert mit 2 als Kurzwahlzeichen
 *     DF_Prompt( 1, -1, 'Men-Punkt ~2')
 *              // Prompt in 3. Zeile zentriert mit Hinweistext definieren
 *     DF_Prompt( 2,NIL, 'Men-Punkt ~3', 'Damit whlen Sie Men-Punkt 3.')
 *              // dito, jedoch in "Clipper-Form" mit #translate-Umleitung
 *     @ 3, -1 PROMPT 'Ende' MESSAGE 'Programm beenden'
 *              // Prompt-Men-System starten
 *     nVar := DF_Prompt(nVar)
 *  $SEEALSO$
 *     DF_MenuTo()
 *  $KATEGORIE$
 *     10
 *  $LIBS$
 *     NT-TOOLS
 *  $END$
 */
PROCEDURE DF_Prompt ( nZeile, nSpalte, cBez, cInfo )
*
LOCAL nPos, Ch, nArrPos
*
IF ValType(nSpalte) # 'N' .OR. nSpalte < 0
  nSpalte := Round((MaxCol() +1 -Len(CharRem('~', cBez))) / 2, 0)
ENDIF
*
nPos := At('~', cBez)
IF Empty(nPos)
  nPos := CountLeft(cBez) +1
  Ch   := SubStr(cBez, nPos, 1)
ELSE
  Ch := SubStr(cBez, nPos +1, 1)       // ~-Zeichen berspringen !
ENDIF
IF Empty(cInfo)
  cInfo := ''
ENDIF
IF Len(Ch) # 1
  Ch := ' '
ENDIF
*
nArrPos := Len(aMenuList) +1
*
AAdd(aMenuList, {nZeile, nSpalte, CharRem('~', cBez), cInfo, nPos, Ch})
cMenuKeys += Upper(Ch)
_DFSetMaxWidth()
*
_DFDrawPrompt(nArrPos)
*
RETURN
*
*Ŀ
*                         MENU TO - Pendant                          
*
*
/*  $DOC$
 *  $FUNCNAME$
 *     DF_MenuTo()
 *  $ONELINER$
 *     Aktiviert ein Prompt-Men-System
 *  $SYNTAX$
 *     DF_MenuTo([<nStartPos>]) -> <nWahlPos>
 *  $ARGUMENTS$
 *     <nSartPos> - Die Nummer des Men-Punkts, der zuerst markiert werden soll.
 *                  Ist dieser Parameter nicht oder mit einem falschen Wert/Typ
 *                  angegeben, wird der erste Men-Punkt markiert.
 *  $RETURNS$
 *     <nWahlPos> - Die Nummer des Men-Punkts der ausgewhlt wurde.
 *                  Wurde die Wahl mit Esc abgebrochen, wird Null zurckgegeben.
 *  $DESCRIPTION$
 *     DF_MenuTo() ist als ein Ersatz fr den MENU TO-Befehl definiert.
 *     Die damit zuvor via DF_Prompt() erstellten Prompts werden daraufhin zur
 *     Auswahl angeboten, wobei der <nStartPos>-te Prompt markiert wird.
 *
 *     Folgende Tasten stehen whrend der Auswahl zur Verfgung:
 *       Aufwrtspfeil - springt zu vorherigem Men-Punkt
 *       Abwrtspfeil  - springt zu folgendem Men-Punkt
 *       Linkspfeil    - springt zu vorherigem Men-Punkt
 *       Rechtspfeil   - springt zu folgendem Men-Punkt
 *       Pos1          - erster Men-Punkt
 *       Ende          - letzter Men_Punkt
 *       Bild         - Aktuellen Men-Punkt whlen
 *       Bild         - Aktuellen Men-Punkt whlen
 *       Return        - Aktuellen Men-Punkt whlen
 *       Esc           - Abbruch, Rckgabe von 0
 *       <Taste>       - Whlen des damit verbundenen Men-Punktes
 *
 *     Wird die Taste fr ein hervorgehobenes Zeichen eines Men-Punkts
 *     gedrckt, so wird Markierung auf diesen Men-Punkt gesetzt und dieser
 *     ausgewhlt.
 *     Wird ein Men-Punkt ausgewhlt, so wird die entsprechende Nummer oder,
 *     wurde Esc gedrckt, eine Null zurckgegeben.
 *
 *     Befindet sich die Markierung auf dem ersten Men-Punkt und es wird
 *     Linkspfeil/Aufwrtspfeil gedrckt und SET WRAP ist auf ON gesetzt,
 *     wird der letzte Men-Punkt markiert. ebenso umgekehrt.
 *
 *     Die Men-Punkte werden in der gerade aktiven Farbe "Stanard" angezeigt.
 *     Ein markierter Men-Punkt wird in der Farbe "Enhanced" dargestellt.
 *     Hervorgehobene Auswahlzeichen besitzen die Farbe "Unselected".
 *
 *     ACHTUNG !
 *     - Eine Verschachtelung von MENU TOs ist (noch) nicht mglich.
 *     - DF_MenuTo() kann nur in Verbindung mit DF_Prompt() eingesetzt werden.
 *
 *  $EXAMPLES$
 *              // normaler Prompt in oberer, linken Ecke definieren
 *     DF_Prompt( 0,  0, 'Men-Punkt 1')
 *              // Prompt in 2. Zeile zentriert mit 2 als Kurzwahlzeichen
 *     DF_Prompt( 1, -1, 'Men-Punkt ~2')
 *              // Prompt in 3. Zeile zentriert mit Hinweistext definieren
 *     DF_Prompt( 2,NIL, 'Men-Punkt ~3', 'Damit whlen Sie Men-Punkt 3.')
 *              // dito, jedoch in "Clipper-Form" mit #translate-Umleitung
 *     @ 3, -1 PROMPT 'Ende' MESSAGE 'Programm beenden'
 *              // Prompt-Men-System starten
 *     nVar := DF_Prompt(nVar)
 *  $SEEALSO$
 *     DF_MenuTo()
 *  $KATEGORIE$
 *     10
 *  $LIBS$
 *     NT-TOOLS
 *  $END$
 */
FUNCTION DF_MenuTo ( nWahl )
*
LOCAL nOldWahl, lIsWrap, nKey, lReady
*
IF Empty(nWahl)
  nWahl := 1
ENDIF
*
lReady   := .F.
nOldWahl := nWahl
lIsWrap  := Set(_SET_WRAP)
*
DO WHILE .NOT. lReady
  _DFDrawPrompt(nWahl, .T.)
  nKey := 0
  DO WHILE nKey = 0
    nKey := Inkey()
  ENDDO
  *
  nOldWahl := nWahl
  *
  DO CASE
    CASE (nKey = K_RETURN) .OR. (nKey = K_PGUP) .OR. (nKey = K_PGDN)
      lReady := .T.
    CASE nKey = K_ESC
      nWahl := 0
      lReady := .T.
    CASE nKey = K_HOME
      nWahl := 1
    CASE nKey = K_END
      nWahl := Len(aMenuList)
    CASE (nKey = K_UP) .OR. (nKey = K_LEFT)
      nWahl--
      IF nWahl < 1
        nWahl := IF(lIsWrap, Len(aMenuList), 1)
      ENDIF
    CASE (nKey = K_DOWN) .OR. (nKey = K_RIGHT)
      nWahl++
      IF nWahl > Len(aMenuList)
        nWahl := IF(lIsWrap, 1, Len(aMenuList))
      ENDIF
    CASE (nKey >= 0) .AND. (nKey <= 255) // prfen, ob Taste
      nWahl := At(Upper(Chr(nKey)), cMenuKeys) // Men-Punkt ermitteln
      IF Empty(nWahl)                  // keiner da ?
        nWahl := nOldWahl              // alten Wert holen
      ELSE
        lReady := .T.
      ENDIF
  ENDCASE
  *
  IF nOldWahl # nWahl
    _DFDrawPrompt(nOldWahl, .F.)
  ENDIF
ENDDO
*
aMenuList   := {}                      // Listen wieder lschen !
cMenuKeys   := ''
nMenuWidth := 0
*
Return(nWahl)
*
*Ŀ
*              einen Menpunkt auf Bildschirm darstellen             
*
/*
 * Private Routine zur Anzeige eines Men-Punkts auf dem Bildschirm
 *
 * Syntax:
 *   _DFDrawPrompt(<nArrPos>, <lSelected>)
 *
 * <nArrPos>   gibt die Position im Array mit den Men-Punkten an
 * <lSelected> gibt an, ob der Menpunkt gerade markiert ist
 *
 */
STATIC PROCEDURE _DFDrawPrompt ( nArrPos, lSelected )
*
LOCAL nLine, lCenter
*
IF Empty(lSelected)
  lSelected := .F.
ENDIF
*
IF .NOT. Empty(nMenuWidth)             // MESSAGEs anzeigen ?
  nLine   := Set(_SET_MESSAGE)
  lCenter := Set(_SET_MCENTER)
  @ nLine, 0 SAY IF(lCenter, Center(aMenuList[nArrPos, MT_INFO], NIL, NIL, .T.), PadRight(aMenuList[nArrPos, MT_INFO], nMenuWidth))
ENDIF
*
IF lSelected
  Enhanced()
ENDIF
*
@ aMenuList[nArrPos, MT_POS_X], aMenuList[nArrPos, MT_POS_Y] SAY ;
  aMenuList[nArrPos, MT_TEXT]
*
IF lSelected
  Standard()
  RETURN
ENDIF
*
Unselected()
@ aMenuList[nArrPos, MT_POS_X], ;
  aMenuList[nArrPos, MT_POS_Y] +aMenuList[nArrPos, MT_KEYPOS] -1 SAY ;
  aMenuList[nArrPos, MT_KEY]
Standard()
*
RETURN
*
*Ŀ
*                    breiteste MESSAGE-Zeile suchen                  
*
/*
 * Private Routine zur Ermittlung des breitesten Message-Feldes
 *
 * Syntax:
 *   _DFSetMaxWidth()
 *
 */
STATIC PROCEDURE _DFSetMaxWidth
*
LOCAL I
*
nMenuWidth := 0
*
FOR I := 1 TO Len(aMenuList)
  nMenuWidth := Max(nMenuWidth, Len(aMenuList[I, MT_INFO]))
NEXT
*
RETURN
*
